// Learn cc.Class:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    properties: {
        content:cc.Node,
        prefab:cc.Prefab
    },

    // LIFE-CYCLE CALLBACKS:

    onLoad () {
        this.container = {};
    },

    start () {
        var list = [];
        var res = ['guaiC1aTexture','guaiC1bTexture'];
        for (var i = 0 , len = 10; i < len; i++) {
            list.push(res[Math.floor(Math.random()*res.length)]);
        }
        var data = {
            content:this.content,
            prefab:this.prefab,
            list:list,
            ext:this
        }
        this.refreshView(data);
    },

    getResource(name){
        return this.container[name];
    },

    loadSpine(spineName,callBack) {
        var spine = this.getResource(spineName);
        if (spine) {
            return callBack(spine);
        }
        cc.loader.loadRes("spine/"+spineName,sp.SkeletonData, function (err, spineData) {
            if (err) return cc.error(err);
            this.container[spineData._name] = spineData;
            callBack(spineData);
        }.bind(this));

    },

    refreshView (data){
        var content = data.content;
        var list = data.list;
        var prefab = data.prefab;
        var ext = data.ext;
        var msgItem;
        for(var i = 0; i < list.length; i++) {
            if(content.children[i]) {
                msgItem = content.children[i];
            }
            else {
                msgItem = cc.instantiate(prefab);
                msgItem.parent = content;
            }
            msgItem.getComponent(prefab.name).init(i, list[i],ext);
        }
        if(content.children.length > list.length) {
            for(var j = list.length; j < content.children.length; ) {
                var node = content.children[j];
                node.removeFromParent();
                node.destroy();
            }
        }
    },


    // update (dt) {},
});
